              #include <errno.h>
              #include <limits.h>
              #include <signal.h>
              #if HAVE_SYS_TIME_H
               #include <sys/time.h>
              #endif
              #include <time.h>
              #include <unistd.h>
              #include <stdio.h>
              static void
              check_for_SIGALRM (int sig)
              {
                if (sig != SIGALRM)
                  _exit (1);
              }

              int
              main ()
              {
                static struct timespec ts_sleep;
                static struct timespec ts_remaining;
                static struct sigaction act;
                if (! nanosleep)
                  return 2;
                act.sa_handler = check_for_SIGALRM;
                sigemptyset (&act.sa_mask);
                sigaction (SIGALRM, &act, NULL);
                ts_sleep.tv_sec=12; /* changed this to 2 secs (original test uses MAX_INT) */
                ts_sleep.tv_nsec = 999999999;
                alarm (1);
                if (nanosleep (&ts_sleep, &ts_remaining) != -1)
                  {
                    printf("\nAfter nanosleep, but no interrupt\n"); return 4;
                 }
                else
                   printf("\nAfter nanosleep and interrupted\n");
                if (errno != EINTR)
                  return 5;
                if (ts_remaining.tv_sec <= ts_sleep.tv_sec - 10)
                  return 6;
                return 0;
              }

